<?php
if (defined('_PS_CONFIG_DIR_')) {
    require_once _PS_CONFIG_DIR_ . 'config.inc.php';
}

if (defined('_PS_MODULE_DIR_')) {
    include _PS_MODULE_DIR_ . '/elementpay/events/payserver_event_handler.php';
    include _PS_MODULE_DIR_ . '/elementpay/classes/payserver_webhooks.php';
}

class ElementpayWebhooksModuleFrontController extends ModuleFrontController
{
    public $auth = false;

    protected $payserver_event_handler;
    protected $payserver_webhooks;

    public function __construct()
    {
        parent::__construct();

        $this->setPayserverEventHandler(new PayserverEventHandler());
        $this->setPayserverWebhooks(new PayserverWebhooks());
    }

    public function setPayserverEventHandler($payserver_event_handler)
    {
        $this->payserver_event_handler = $payserver_event_handler;
    }

    public function setPayserverWebhooks($payserver_webhooks)
    {
        $this->payserver_webhooks = $payserver_webhooks;
    }

    protected function isRequestValid($request_body)
    {
        return !empty($request_body);
    }

    public function postProcess()
    {
        $this->setTemplate('module:elementpay/views/templates/front/webhooks.tpl');

        $request_body = $this->payserver_webhooks->getRequestBody();


        if (! $this->isRequestValid($request_body)) {
            $this->payserver_webhooks->sendRawHeaderAsBadRequest();
            return;
        }

        $this->payserver_event_handler->handle($request_body);
    }
}