(function() {
    var payserverDisplaySelectBankMessage = function payserverDisplaySelectBankMessage() {
        $.fancybox.open([
                {
                    type: 'inline',
                    autoScale: true,
                    minHeight: 30,
                    content: $('#payserver-select-bank-message').html(),
                }],
            {
                padding: 0,
            });
    };

    var payserverDisplayInvalidValueMessage = function payserverDisplayInvalidValueMessage() {
        $.fancybox.open([
                {
                    type: 'inline',
                    autoScale: true,
                    minHeight: 30,
                    content: $('#payserver-invalid-value-message').html(),
                }],
            {
                padding: 0,
            });
    };

    var payserverDisplayEmptyFieldMessage = function payserverDisplayEmptyFieldMessage() {
        $.fancybox.open([
                {
                    type: 'inline',
                    autoScale: true,
                    minHeight: 30,
                    content: $('#payserver-empty-value-message').html(),
                }],
            {
                padding: 0,
            });
    };

    var payserverHasAnyBankSelected = function payserverHasAnyBankSelected() {
        let paymentOptionList = $('[name="paymentMethod"]:visible');

        return !!paymentOptionList.filter(":checked").length;
    };

    var ispayserverOptionSelected = function ispayserverOptionSelected() {
        let payserverOptions = $('[data-module-name^="payserver_"]');

        return !!payserverOptions.filter(":checked").length
    };

    let validator = function validator() {
        var attrs = $('.attr:visible');
        if (!attrs) {
            return true;
        }

        let result = true;
        attrs.each(function() {
            var $item = $(this),
                regText = $item.data('regexp') + '';

            if (regText) {
                result = (new RegExp(regText)).test($item.val());
            } else if ($item.data('required')) {
                result = !!$item.val();
            }

            if (!$item.val() && $item.prop('required')) {
                $item.addClass('invalid');
                payserverDisplayEmptyFieldMessage();
                return false;
            }

            if (!result) {
                if ($item.val()) {
                    $item.addClass('invalid');
                    payserverDisplayInvalidValueMessage();
                    return false;
                } else {
                    result = true;
                }
            }
        });
        return result;
    };

    $(function() {
        let $paymentConfirmationButton = $('#payment-confirmation button');

        $('.attr').on('click', function() {
            $(this).removeClass('invalid');
        });

        $('.PaymentMethodRadio').change(function() {
            var $radio = $(this);
            if ($radio.is(':checked')) {
                ($radio.siblings('.attrList')).children('.attr').
                    removeAttr('disabled');
            } else {
                ($radio.siblings('.attrList')).children('.attr').
                    attr('disabled', 'disabled');
            }
        });

        $paymentConfirmationButton.on('click', function(event) {
            let $canProceed = true;

            if (!ispayserverOptionSelected()) {
                $canProceed = false;
            }

            if ($canProceed && !payserverHasAnyBankSelected()) {
                payserverDisplaySelectBankMessage();
                $canProceed = false;
            }

            if ($canProceed && !validator()) {
                $canProceed = false;
            }

            if (!$canProceed) {
                event.preventDefault();
                event.stopPropagation();
            }
        });
    });
})();